package Voyager.rtsp;

import java.io.*;

/**
 *  Parser for x-bob/session-description.
 *
 *  Format:
 *    n-streams
 *    ssrc1
 *    ssrc2
 *    ...
 *    ssrcn
 *    name
 *    description line 1
 *    ...
 *    description line m
 */
  
public class BobSDParser
{
    Session parseResponse(Response response)
    {
	if (!response.headers().get("Content-Type").equals(typeName))
	{
	    System.out.println("BobSDParser::parseReponse: invalid type");
	    return null;
	}

	Session session = new Session();

	ByteArrayInputStream bstream = new ByteArrayInputStream(response.body());
	DataInputStream dstream = new DataInputStream(bstream);

	int nStreams;

	try {
	    String nStreamsStr = dstream.readLine();

	    nStreams = Integer.parseInt(nStreamsStr);

	    for (int i = 0; i < nStreams; i++)
	    {
		String ssrc = dstream.readLine();
		session.addStream(ssrc);
	    }

	    String name = dstream.readLine();
	    session.setName(name);

	    String description = "";
	    String line;
	    for (line = dstream.readLine(); line != null; line = dstream.readLine())
	    {
		description.concat(line);
	    }
	    session.setDescription(description);
	}
	catch (IOException iox)
	{
	    return session = null;
	}


	return session;
    }

    public static final String typeName = "x-bob/session-description";
}
