package Voyager.rtsp;

public interface Client
{
    public ConnectResult connect(String host, int port);
    public ConnectResult connect(String url);
    public DescribeSessionResult describeSession(String sessionId);
    public DescribeStreamResult describeStream(String sessionId, String stream);

    public SetupStreamResult setupStream(String sessionId, String stream,
					 String transportInfo,
					 int rtspSession);
    
    public TeardownStreamResult teardownStream( String sessionId , String stream , int rtspSession );
    
    
    public RecordSessionResult recordSession(String sessionId, int rtspSession);
    public PlaySessionResult playSession(String sessionId, int rtspSession);
    public PlayStreamResult playStream(String sessionId, String stream);
    public PauseStreamResult pauseStream(String sessionId, String stream);
}
