package Voyager.rtsp;

import java.util.*;
import java.io.*;

public class Stream
{
    Stream(String name)
    {
	name_ = name;
	init();
    }

    Stream()
    {
	name_ = null;
	init();
    }

    void init()
    {
	parameters_ = new Hashtable();
    }

    public String key() { return name_; }

    public void setName(String name) { name_ = name; }
    public String name() { return name_; }

    public static Stream parseResponse(Response response)
    {    
	String contentType = (String) response.headers().get("Content-Type");
	Stream stream = null;

	if (contentType.equals("x-bob/stream-description"))
	{
	    //
	    // This is just a list of name/value pairs
	    //

	    stream = new Stream();

	    DataInputStream bodyStream = new DataInputStream(new ByteArrayInputStream(response.body()));

	    try {
		String line;
		for (line = bodyStream.readLine(); line != null;
		     line = bodyStream.readLine())
		{
		    int spaceIdx = line.indexOf(" ");
		    if (spaceIdx < 0)
		    {
			return null;
		    }
		    String key = line.substring(0, spaceIdx);
		    String value = line.substring(spaceIdx + 1);

		    stream.setParameter(key, value);
		}
	    }
	    catch (IOException ex)
	    {
		stream = null;
	    }
		
	}

	return stream;
    }

    public String setParameter(String name, String value)
    {
	return (String) parameters_.put(name, value);
    }

    public Enumeration getParameterNames()
    {
	return parameters_.keys();
    }

    public String getParameter(String name)
    {
	return (String) parameters_.get(name);
    }

    String name_;

    Hashtable parameters_;
}
