package Voyager.rtsp.clients;

import java.awt.*;
import java.awt.event.*;

public class SessionInfoPanel extends Panel
{
    TextField nameText_;
    TextArea descriptionText_;
    RecordUI controller_;
    
    public SessionInfoPanel(RecordUI ui)
    {
	super();

	controller_ = ui;
	
	GridBagLayout layout = new GridBagLayout();
	setLayout(layout);

	GridBagConstraints c = new GridBagConstraints();

	c.gridwidth = GridBagConstraints.REMAINDER;
	c.weightx = 1.0;
	c.fill = GridBagConstraints.HORIZONTAL;
	Label l = new Label("Enter a name and description for this session.");
	layout.setConstraints(l, c);
	add(l);

	//

	Panel p = new Panel();
	p.setLayout(new BorderLayout());

	l = new Label("Session name:");
	p.add("West", l);
	nameText_ = new TextField();
	p.add("Center", nameText_);

	c.gridwidth = GridBagConstraints.REMAINDER;
	c.fill = GridBagConstraints.HORIZONTAL;
	c.weightx = 1.0;

	layout.setConstraints(p, c);
	add(p);

	//

	c.fill = GridBagConstraints.BOTH;

	p = new Panel();
	p.setLayout(new BorderLayout());

	p.add("North", new Label("Description:", Label.LEFT));
	descriptionText_ = new TextArea();
	p.add("Center", descriptionText_);
	      
	layout.setConstraints(p, c);
	add(p);

	//

	c.fill = GridBagConstraints.NONE;

	c.anchor = GridBagConstraints.SOUTHEAST;

	c.weightx = 1.0;
	c.weighty = 1.0;
	c.gridwidth = GridBagConstraints.RELATIVE;

	Button button = new Button("Next >");
	layout.setConstraints(button, c);
	add(button);

	// Register the UI

	ActionListener listener = new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		controller_.sessionInfoPanelDone();
	    }
	};

	button.addActionListener(listener);

	//

	c.weightx = 0.0;
	c.insets.left = 4;
	c.gridwidth = GridBagConstraints.REMAINDER;

	button = new Button("Help");
	layout.setConstraints(button, c);
	add(button);
	button.setEnabled(false);
    }

    String getSessionName() { return nameText_.getText(); }
    String getSessionDescription() { return descriptionText_.getText(); }
}
