package Voyager.util;

import java.applet.*;
import java.awt.*;
import java.util.Properties;
import java.net.*;

import Voyager.db.clients.*;

public class VoyAppletContext extends VoyContext
{
  private SDBApplet applet_;
    
  public VoyAppletContext( SDBApplet applet )
  {
    super.init();

    applet_ = applet;
  }

    // These calls are no-ops in this context
    public void setRatFlag( boolean qRat )
    {
    }
    public void setKeepMediaFlag( boolean qKeep )
    {
    }
    public void killMediaClients( )
    {
    }

  public AppletContext getContext()
  {
    return applet_.getAppletContext();
  }

  public void showStatus( String str )
  {
    applet_.showStatus( str );
  }
	
  public boolean getCLaunched() {
    return false;
  }

  public void launchMediaClients( String serverHost )
  {
    URL url = null;
    String rootURL = "http://voyager.mcs.anl.gov/ivan-voyager/x/sc.pl?command=play";
    String audioInfo = "&audiohost="+serverHost+"&audioport="+getAudioPort();
    String videoInfo = "&videohost="+serverHost+"&videoport="+getVideoPort();

    try
      {
	url = new URL(rootURL + audioInfo + videoInfo);
	
	AppletContext ac = applet_.getAppletContext( );
	
	ac.showDocument( url , "_VOYClient");
      }
    catch ( MalformedURLException e )
      {
	System.err.println( e );
      }
    finally
      {
	System.out.println(url);
      }

  }

    public void launchMediaClients( String audDest , String vidDest , String audPort , String vidPort )
    {
	// to be implemented
    }

  public org.omg.CORBA.ORB initCorba( )
  {
    orb_ = org.omg.CORBA.ORB.init( applet_ , new java.util.Properties( ) );
    return orb_;
  }

  public void shutdown() {
    java.lang.Runtime rt = java.lang.Runtime.getRuntime();
    rt.exit(0);
  }
}
