package Voyager.util;

import org.omg.CORBA.ORB;
import java.lang.String;
import Voyager.db.*;
import java.net.*;
import java.io.*;

public abstract class VoyContext
{
  private static int audioPort_ = 0;
  private static int videoPort_ = 0;
  private static String audioDest_ = "";
  private static String videoDest_ = "";
  private VOY_Database db_ = null;
  protected String ior_ = null;
  protected org.omg.CORBA.ORB orb_ = null;
  protected boolean cLaunched_ = false;
  public int getAudioPort() { return audioPort_; };
  public int getVideoPort() { return videoPort_; };
    public String getAudioDest( ) { return audioDest_; };
    public String getVideoDest( ) { return videoDest_; };
  public String getIOR() { return ior_ ; }
  public abstract boolean getCLaunched();
  public abstract void showStatus( String msg );
  public abstract void launchMediaClients( String serverHost );
  public abstract void launchMediaClients( String audDest, String vidDest , String audPort, String vidPort );
  public abstract void killMediaClients(  );
  public abstract void setKeepMediaFlag( boolean qKeep  );
  public abstract void setRatFlag(  boolean  qRat );
  public void registerClosable(Closable c) {}
  public void removeClosable(Closable c) {}
  public abstract org.omg.CORBA.ORB initCorba(  );
  public abstract void shutdown();

    public String serverHost_;

    public void serverHost( String server ) 
    {
	serverHost_ = new String( server );
    }

    public String serverHost( ) { return serverHost_; };
  
  public void init( )
  {
    java.util.Calendar cal = java.util.Calendar.getInstance();
    java.util.Date date = cal.getTime();
    java.util.Random randomSession = new java.util.Random(date.getTime());
      
    while(audioPort_  < 1)
	audioPort_ = ((randomSession.nextInt() + 1024) % 32767) * 2;
      
    while(videoPort_ < 1 || videoPort_ == audioPort_)
	videoPort_ = ((randomSession.nextInt() + 1024) % 32767) * 2;

    audioDest_ = new String( "" );
    videoDest_ = new String( "" );

    try {
	audioDest_ = InetAddress.getLocalHost( ).getHostName( );
	videoDest_ = audioDest_;
    } catch (java.net.UnknownHostException e ) {
	showStatus( "Unknown Host" + e );
    }


    showStatus("Dest A: "+ audioDest_ );
    showStatus("Dest V: "+ videoDest_ );
    showStatus("Port A: "+ Integer.toString(audioPort_));
    showStatus("Port V: "+ Integer.toString(videoPort_));
  }

  public void retrieveIOR(URL url)
    throws org.omg.CORBA.SystemException 
  {
    showStatus("Reading in IOR");
    try {
      String ior = (new BufferedReader(new InputStreamReader(url.openStream()))).readLine();
      setIOR(ior);
    } catch (MalformedURLException e) {
      System.out.println("Bad URL format in DBURL parameter: " + url);
    } catch (IOException e) {
      System.out.println("Error reading from URL.");
    }
  }

  public void setIOR(String ior)
  {
    showStatus("Setting IOR to: " + ior);
    ior_ = ior;
  }
  
  public VOY_Database getDB() 
  { 
    showStatus("Getting DB");

    if(db_ == null) {
      if(orb_ == null) {
	  showStatus("orb null");
	  return(null);
      } else {
	if(ior_ == null) {
	  showStatus("ior null");
	  return(null);
	} else {
	  showStatus("Converting ior to object");
	  org.omg.CORBA.Object obj = orb_.string_to_object(ior_);

	  showStatus("Narrowing object");
	  db_ = VOY_DatabaseHelper.narrow(obj);

	  showStatus("Returning narrowed db "+ db_ );
	  return(db_);
	}
      }
    } else {
      showStatus("Had db already, returning it");
      return db_ ; 
    }
  }
}

  
