#ifndef _Playback_Manager_h
#define _Playback_Manager_h

#include <map.h>
#include "Play_Session_ID.h"

#include "Voyager_Corba.h"

class RTSP_Setup_Request;
class RTSP_Play_Request;
class Transport_Manager;
class Play_Session_Manager;
class RTSP_Teardown_Request;

class Playback_Manager
{
public:
    Playback_Manager(Transport_Manager *, VOY_Database_ptr , VOY_String );

    void handleSetup(RTSP_Setup_Request *);

    void handlePlay(RTSP_Play_Request *);

    void handleTeardown( RTSP_Teardown_Request* );

    short isPlaySession( RTSP_Teardown_Request* );

    typedef map<Play_Session_ID, Play_Session_Manager *,
	        less<Play_Session_ID> > Play_Session_Map;
private:
    int nextSessionId_;
    
    Transport_Manager *transportManager_;
    Play_Session_Map playSessionMap_;
    VOY_Database_var databaseRef_;
    VOY_String payFreqFileName_;
};

#endif /* _Playback_Manager_h */
