#ifndef _Playback_Network_Transport_h_
#define _Playback_Network_Transport_h_

#include "config.h"
#include"Network_Endpoint.h"


/////////////////////////////////////////////////////////////////////////////
//
// Playback_Network_Transport.h
//
// Revision History
//     26 jan 98 - lisa - adapted from Network_Transport
//

#include <ace/SOCK_Dgram.h>
#include <ace/SOCK_Dgram_Mcast.h>
#include <ace/INET_Addr.h>

#include <ace/Event_Handler.h>

class Playback_Network_Transport : public ACE_Event_Handler
{
public:

    Playback_Network_Transport( Network_Endpoint );
    ~Playback_Network_Transport( );

    void playRtpPacket( int , char* , int );
    void playRtcpPacket( char* , int );

    virtual int handle_input( ACE_HANDLE fd );

    short qError( ) { return qError_; };

    const Network_Endpoint& endpoint( void ) const { return endpoint_; }

private:
    Network_Endpoint endpoint_;

    ACE_INET_Addr rtp_address_;
    ACE_INET_Addr rtcp_address_;

    int isMulticast_;
    ACE_SOCK_Dgram rtp_sock_;
    ACE_SOCK_Dgram rtcp_sock_;

    ACE_SOCK_Dgram_Mcast rtp_mc_sock_;
    ACE_SOCK_Dgram_Mcast rtcp_mc_sock_;

    short qError_;
};

inline ostream &operator<<( ostream &os, const Playback_Network_Transport& nt )
{
    const Network_Endpoint &ePoint = nt.endpoint( );
    os << "Playback_Network_Transport:  Network_Endpoint=" << ePoint;
    os << endl;
    return os;
}

#endif
