#ifndef _RTCP_Packet_Sink_h
#define _RTCP_Packet_Sink_h

/*
 * Mixin class for objects that can sink an RTCP packet stream.
 */

#include "RTCP_Packet.h"
#include "ace/INET_Addr.h"
#include "ace/SOCK_Dgram.h"

class RTCP_Packet_Sink
{
public:
    virtual void handlePacket(RTCP_Packet::RTCP_Header *packet_header,
			       char *packet, int packet_size,
			       ACE_INET_Addr &packet_source,
			       ACE_SOCK_Dgram *sock) = 0;
			       
    virtual void handleSubpacket(RTCP_Packet::RTCP_Header *packet_header,
			       char *packet, int packet_size,
			       ACE_INET_Addr &packet_source,
				  ACE_SOCK_Dgram *sock) = 0;
			       
};

#endif /* _RTCP_Packet_Sink_h */
