#ifndef _RTCP_Engine_h
#define _RTCP_Engine_h

#include <ace/Svc_Handler.h>
#include <ace/Message_Block.h>
#include <ace/SOCK_Stream.h>
#include <ace/Synch.h>

#include "RTSP_Request_Packet.h"

class Dispatcher;

class RTSP_Engine : public ACE_Svc_Handler<ACE_SOCK_STREAM, ACE_NULL_SYNCH>
{
public:
    RTSP_Engine(Dispatcher *);
    RTSP_Engine();

    virtual int open(void * = 0);
    virtual int handle_input (ACE_HANDLE fd = ACE_INVALID_HANDLE);

    void sendf(char *fmt, ...);

    void handleRequest(RTSP_Request_Packet *request);

    const ACE_INET_Addr &peerAddr() const { return peerAddr_; }

protected:
    ACE_INET_Addr peerAddr_;

    RTSP_Request_Packet *request_;
    Dispatcher *dispatcher_;
    
    ACE_Message_Block mb_;
};

#endif
