#ifndef _RTSP_Setup_Request_h
#define _RTSP_Setup_Request_h

#include "RTSP_Request.h"

#include <stream.h>

class RTSP_Transport_Info;

class RTSP_Setup_Request : public RTSP_Request
{
public:
    RTSP_Setup_Request();

    virtual int setRequestPacket(RTSP_Request_Packet *);

    virtual void dispatch(Dispatcher *);

    RTSP_Transport_Info *transportInfo() { return transportInfo_; }
    int serverSessionId() { return serverSessionId_; }

    virtual ostream& put(ostream &) const;

    int isModePlay( void ) const;
    int isModeRecord( void ) const;

protected:
    int serverSessionId_;

    RTSP_Transport_Info *transportInfo_;

    int parseTransport(RTSP_Request_Packet *r);
    int parseSession(RTSP_Request_Packet *r);
};

#endif /* _RTSP_Setup_Request_h */
