#ifndef _Record_Manager_h
#define _Record_Manager_h

#include <map.h>
#include "Record_Session_ID.h"

#include "Voyager_Corba.h"

class RTSP_Setup_Request;
class RTSP_Record_Request;
class Transport_Manager;
class Record_Session_Manager;
class RTSP_Teardown_Request;

class Record_Manager
{
public:
    Record_Manager(Transport_Manager *, VOY_Database_ptr);

    void handleSetup(RTSP_Setup_Request *);

    void handleRecord(RTSP_Record_Request *);

    void handleTeardown( RTSP_Teardown_Request* );

    short isRecordSession( RTSP_Teardown_Request* );

    typedef map<Record_Session_ID, Record_Session_Manager *,
	        less<Record_Session_ID> > Record_Session_Map;
private:
    int nextSessionId_;
    
    Transport_Manager *transportManager_;
    Record_Session_Map recordSessionMap_;
    VOY_Database_var databaseRef_;
};

#endif /* _Record_Manager_h */
