#ifndef _Record_Network_Transport_h_
#define _Record_Network_Transport_h_

#include "config.h"
#include "Network_Endpoint.h"

/////////////////////////////////////////////////////////////////////////////
//
// Record_Network_Transport.h
//
// Revision History
//     26 jan 98 - lisa - adapted from Network_Transport
//

#include <ace/SOCK_Dgram.h>
#include <ace/SOCK_Dgram_Mcast.h>
#include <ace/INET_Addr.h>

class Record_Network_Transport 
{
public:

    Record_Network_Transport( Network_Endpoint );
    ~Record_Network_Transport( );

    const Network_Endpoint& endpoint( void ) const { return endpoint_; }

    int isMulticast( void ) { return isMulticast_; }

    ACE_SOCK_Dgram* rtpSocket( void );
    ACE_SOCK_Dgram* rtcpSocket( void );

    short qError( ) { return qError_; };
    
private:
    Network_Endpoint endpoint_;

    ACE_INET_Addr rtp_address_;
    ACE_INET_Addr rtcp_address_;

    int isMulticast_;
    
    ACE_SOCK_Dgram rtp_sock_;
    ACE_SOCK_Dgram rtcp_sock_;

    ACE_SOCK_Dgram_Mcast rtp_mc_sock_;
    ACE_SOCK_Dgram_Mcast rtcp_mc_sock_;
    
    short qError_;
};

inline ostream &operator<<( ostream &os, const Record_Network_Transport& nt )
{
    const Network_Endpoint &ePoint = nt.endpoint( );
    os << "Record_Network_Transport:  Network_Endpoint=" << ePoint;
    os << endl;
    return os;
}

#endif
