#ifndef _Stream_Archive_Hash_h_
#define _Stream_Archive_Hash_h_

#include "ace/Time_Value.h"

class Stream_Archive;

class Stream_Archive_Hash_Bucket
{
public:
    Stream_Archive_Hash_Bucket( long ssrc , Stream_Archive *dw, 
Stream_Archive_Hash_Bucket* next = 0 );
    Stream_Archive_Hash_Bucket();

    long ssrc_;
    Stream_Archive* streamArchive_;

    Stream_Archive_Hash_Bucket* next_;
};

class Stream_Archive_Hash
{
public:
    Stream_Archive_Hash( int size = 1031 );
    ~Stream_Archive_Hash( );

    void add( long ssrc, Stream_Archive* );
    void remove( long ssrc );
    Stream_Archive* lookup( long ssrc );

    void callTick( ACE_Time_Value , ACE_Time_Value , ACE_Time_Value );
    void callTerminate( );
    
protected:
    int size_;
    Stream_Archive_Hash_Bucket* elements_;

    Stream_Archive_Hash_Bucket* getBucket( long ssrc );

};

#endif
