#ifndef _Voyager_Server_h
#define _Voyager_Server_h

class Session_Manager;
class RTSP_Acceptor;
class Dispatcher;
class Transport_Manager;
class Playback_Manager;
class Record_Manager;
class Corba_Manager;

#include "Voyager_Corba.h"

class Voyager_Server
{
public:
    Voyager_Server();

    void init(int &argc, char **);

    void run();

    Session_Manager *sessionManager() { return sessionManager_; }

    VOY_Database_ptr databaseRef() { return databaseRef_; }

private:
    void processArgs(int &argc, char **argv);

    void initCorba(int &argc, char **argv);
    void initServerObjects();
    void initAcceptor();

    int done_;

    int listenPort_;
    char *refFile_;

    Dispatcher *dispatcher_;
    Session_Manager *sessionManager_;
    RTSP_Acceptor *acceptor_;
    Transport_Manager *transportManager_;
    Playback_Manager *playbackManager_;
    Record_Manager *recordManager_;

    VOY_Database_var databaseRef_;

    Corba_Manager *corbaManager_;
    VOY_String payFreqFileName_;
};

#endif /* _Voyager_Server_h */
