#include "Voyager_Stream.h"
#include "RTSP_Request_Packet.h"
#include "RTSP_Describe_Request.h"
#include "RTSP_Response.h"
//#include "Voyager_DB.h"

//#include <zdb.h>

Voyager_Stream::Parameter Voyager_Stream::parameters_[] = {
    { "start_time", DOUBLE, NULL, &Voyager_Stream::startTime_ , NULL},
    { "starting_timestamp", DOUBLE, NULL, &Voyager_Stream::startingTimestamp_ , NULL},
    { "synch_ntp_timestamp", DOUBLE, NULL, &Voyager_Stream::synchNTPTimestamp_ , NULL},
    { "synch_rtp_timestamp", INT, &Voyager_Stream::synchRTPTimestamp_, NULL , NULL},
    { "duration", DOUBLE, NULL, &Voyager_Stream::duration_, NULL},
    { "packets_seen", INT,  &Voyager_Stream::packetsSeen_, NULL , NULL},
    { "packets_missed", INT,  &Voyager_Stream::packetsMissed_, NULL , NULL},
    { "bytes", INT, &Voyager_Stream::bytes_, NULL, NULL},
    { NULL }
};

Voyager_Stream::Voyager_Stream(Voyager_Session_ID id, char *ssrc) :
    sessionId_(id), ssrc_(ssrc)
{
}

void Voyager_Stream::loadFromDB(VOY_Database_var db)
{
  StreamKeyValSeq_var keyval;
  
  keyval = db->getStreamKeyValues(sessionId().id(), ssrc());
  
  for(int i = 0; i < keyval->length(); i++)
    setParameter(keyval[i].key, keyval[i].value);

//     ZSQL *sql = db->sql();

//     sql->Open("select mkey, mvalue from SessionMetadata where id = %d and ssrc = '%s'",
// 	      (int) sessionId(), ssrc());

//     char key[1024], value[1024];
//     while (sql->GetNextRecord())
//     {
// 	sql->GetSQLData(0, key, sizeof(key));
// 	sql->GetSQLData(1, value, sizeof(value));
// 	setParameter(key, value);
//     }
//     sql->Close();
}

// void Voyager_Stream::loadFromDB(Voyager_DB *db)
// {
//     ZSQL *sql = db->sql();

//     sql->Open("select mkey, mvalue from SessionMetadata where id = %d and ssrc = '%s'",
// 	      (int) sessionId(), ssrc());

//     char key[1024], value[1024];
//     while (sql->GetNextRecord())
//     {
// 	sql->GetSQLData(0, key, sizeof(key));
// 	sql->GetSQLData(1, value, sizeof(value));
// 	setParameter(key, value);
//     }
//     sql->Close();
// }

void Voyager_Stream::setParameter(char *name, char *value)
{
    parameterMap_[name] = value;

    for (int i = 0; parameters_[i].name != NULL; i++)
    {
	Parameter *p = &(parameters_[i]);
	if (strcmp(name, p->name) == 0)
	{
	    switch (p->type)
	    {
	    case INT:
		this->*(p->iptr) = atoi(value);
//		printf("Set int value of %s to %d\n", value, this->*(p->iptr));
		break;

	    case DOUBLE:
		this->*(p->dptr) = atof(value);
//		printf("Set double value of %s to %f\n", value, this->*(p->dptr));
		break;

	    case STRING:
		this->*(p->sptr) = ACE_OS::strdup(value);
//		printf("Set int value of %s to %s\n", value, this->*(p->sptr));
		break;
	    }
	    break;
	}
    }
}

void Voyager_Stream::handleDescribeStream(RTSP_Describe_Request *drequest)
{
    RTSP_Request_Packet *request = drequest->requestPacket();
    
    printf("Voyager stream gets describeStream '%s'\n", ssrc());

    RTSP_Response r(200, "OK", request->sequence());

    r.setHeader("Content-Type", "x-bob/stream-description");

    //
    // Stream description has the metadata stuff
    //
    
    r.bodyInit(1000);

    MAP::iterator iter;

    for (iter = parameterMap_.begin(); iter != parameterMap_.end(); iter++)
    {
	r.bodyAppend((*iter).first.c_str());
	r.bodyAppend(" ");
	r.bodyAppend((*iter).second.c_str());
	r.bodyAppend("\n");
    }
/*
    r.bodyAppendf("packet_types %s\n", packetTypes());
    r.bodyAppendf("duration %f\n", duration());
    r.bodyAppendf("packets_seen %d\n", packetsSeen());
    r.bodyAppendf("packets_missed %d\n", packetsMissed());
    r.bodyAppendf("bytes %d\n", bytes());
    */
    
    r.bodyDone();

    r.send(request->engine());
}
